"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs = require("fs");
var path = require("path");
var bluebird_1 = require("bluebird");
var VBase = (function () {
    function VBase(path) {
        this.defaultPath = "";
        this.basePath = "";
        this.data = {};
        this.files = [];
        this.nameless = false;
        this.filterEnabled = false;
        this.filters = [];
        this.allowedExt = [".js", ".ts", ".json"];
        this.basePath = path;
    }
    VBase.prototype.toAsync = function (cb, self) {
        var _this = this;
        var pcb = bluebird_1.promisify(cb);
        return function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            return __awaiter(_this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4, pcb.apply(self, args)];
                        case 1:
                            _a.sent();
                            return [2];
                    }
                });
            });
        };
    };
    VBase.prototype.toMethods = function () {
        var json = {
            methods: []
        };
        for (var _i = 0, _a = Object.keys(this.data); _i < _a.length; _i++) {
            var key = _a[_i];
            json.methods.push(key);
            json[key] = this.data[key];
        }
        return json;
    };
    VBase.prototype.get = function () {
        return this.data;
    };
    VBase.prototype.set = function (data) {
        if (!data) {
            return;
        }
        this.data = data;
    };
    VBase.prototype.getFiles = function () {
        return this.files;
    };
    VBase.prototype.reset = function () {
        this.data = {};
        this.files = [];
    };
    VBase.prototype.addFile = function (file) {
        if (file === void 0) { file = ""; }
        if (fs.existsSync(file)) {
            this.files.push(file);
        }
    };
    VBase.prototype.getFile = function (file) {
        if (fs.existsSync(file)) {
            var json = require(file);
            return json;
        }
        return null;
    };
    VBase.prototype.extends = function (name, json, data) {
        if (data === void 0) { data = {}; }
        if (this.nameless) {
            data = Object.assign(this.data, json);
        }
        else {
            data[name] = json;
        }
        return data;
    };
    VBase.prototype.generate = function (data) {
        var _this = this;
        if (data === void 0) { data = {}; }
        this.files.forEach(function (file) {
            var json = require(file);
            var name = path.basename(file, path.extname(file));
            data = _this.extends(name, json, data);
        });
        return data;
    };
    VBase.prototype.loadOn = function () {
        this.set(this.load());
    };
    VBase.prototype.parseDir = function (dir) {
        if (dir === void 0) { dir = ""; }
        if (fs.existsSync(dir)) {
            return dir;
        }
        return false;
    };
    VBase.prototype.parseFile = function (dir, file) {
        var absPath = path.resolve(dir, file);
        var stat = fs.statSync(absPath);
        if (stat && stat.isDirectory()) {
            return false;
        }
        if (this.allowedExt.indexOf(path.extname(file)) === -1) {
            return false;
        }
        if (this.filterEnabled && !this._filter(absPath)) {
            return false;
        }
        var loaded = require(absPath);
        if (!this.isType(loaded)) {
            return false;
        }
        return { path: absPath, loaded: loaded };
    };
    VBase.prototype.dirReader = function (dir, iterator) {
        dir = this.parseDir(dir);
        if (dir) {
            var files = fs.readdirSync(dir);
            files.forEach(function (file) {
                return iterator(dir, file);
            });
            this.files = this.files.filter(function (value, index, self) {
                return self.indexOf(value) === index;
            });
        }
        return dir;
    };
    VBase.prototype.load = function (dir, data) {
        var _this = this;
        if (dir === void 0) { dir = ""; }
        if (data === void 0) { data = {}; }
        if (!dir) {
            dir = path.resolve(this.basePath, this.defaultPath);
        }
        if (this.dirReader(dir, function (realDir, file) {
            var parsed = _this.parseFile(realDir, file);
            if (!parsed) {
                return;
            }
            _this.files.push(parsed.path);
            var name = path.basename(parsed.path, path.extname(parsed.path));
            data = _this.extends(name, parsed.loaded, data);
        })) {
            return data;
        }
    };
    VBase.prototype._filter = function (file) {
        var name = path.basename(file, path.extname(file));
        if (this.filters.indexOf(name) !== -1) {
            return file;
        }
        return null;
    };
    return VBase;
}());
exports.VBase = VBase;
//# sourceMappingURL=VBase.js.map