"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var VBase_1 = require("./VBase");
var HTTP_1 = require("./HTTP");
var VHTTPBase = (function (_super) {
    __extends(VHTTPBase, _super);
    function VHTTPBase(path) {
        var _this = _super.call(this, path) || this;
        _this.failurable = false;
        _this.filterEnabled = true;
        _this.filters = HTTP_1.HTTP.methods;
        return _this;
    }
    VHTTPBase.prototype.isType = function (item) {
        return item instanceof Function || item instanceof Array;
    };
    VHTTPBase.prototype.check = function (req) {
        var method = req.method.toLowerCase();
        return this.data[method] || this.data.all;
    };
    VHTTPBase.prototype.checkEx = function (req, scope) {
        var method = req.method.toLowerCase();
        var handler = this.data[method] || this.data.all;
        if (handler instanceof Function) {
            return handler;
        }
        if (handler instanceof Array) {
            return handler;
        }
        if (typeof handler !== "string") {
            return false;
        }
        return this.getDefinition(handler, this.defaultPath, scope);
    };
    VHTTPBase.prototype.getDefinition = function (handler, name, scope) {
        var definitions = scope.definitions;
        var namedHandler = definitions[name];
        if (!namedHandler) {
            return false;
        }
        var result = namedHandler[handler];
        if (!result) {
            return false;
        }
        if (result instanceof Function) {
            return result;
        }
        return false;
    };
    VHTTPBase.prototype.setFailureHandler = function (handler) {
        this.failureHandler = handler;
    };
    VHTTPBase.prototype.extend = function (method, handler) {
        if (!(handler instanceof Function)) {
            return false;
        }
        if (this.filters.indexOf(method) === -1) {
            return false;
        }
        this.data[method] = handler;
        return true;
    };
    VHTTPBase.prototype.getFallback = function (req, scope) {
        var handler = this.failureHandler;
        if (handler instanceof Function) {
            return handler;
        }
        if (typeof handler !== "string") {
            return false;
        }
        return this.getDefinition(handler, "fallbacks", scope);
    };
    VHTTPBase.prototype.process = function (req, res, scope) {
        return __awaiter(this, void 0, void 0, function () {
            var handler, processed, _i, handler_1, f, processed;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        handler = this.checkEx(req, scope);
                        if (!(handler instanceof Function)) return [3, 2];
                        return [4, this._onProcess(handler, req, res, scope)];
                    case 1:
                        processed = _a.sent();
                        return [2, processed];
                    case 2:
                        if (!(handler instanceof Array)) return [3, 6];
                        _i = 0, handler_1 = handler;
                        _a.label = 3;
                    case 3:
                        if (!(_i < handler_1.length)) return [3, 6];
                        f = handler_1[_i];
                        return [4, this._onProcess(f, req, res, scope)];
                    case 4:
                        processed = _a.sent();
                        if (!processed) {
                            return [2, false];
                        }
                        _a.label = 5;
                    case 5:
                        _i++;
                        return [3, 3];
                    case 6: return [2, true];
                }
            });
        });
    };
    VHTTPBase.prototype.onPassed = function (req, res, scope, info, cb) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!(cb instanceof Function)) return [3, 2];
                        return [4, cb(info, req, res, scope)];
                    case 1: return [2, _a.sent()];
                    case 2: return [2, this.onAuthorFailed(info, req, res, scope)];
                }
            });
        });
    };
    VHTTPBase.prototype.onAuthorFailed = function (message, req, res, scope) {
        res.status(403).end("Access Denied!");
        return false;
    };
    VHTTPBase.prototype._onProcess = function (func, req, res, scope) {
        return __awaiter(this, void 0, void 0, function () {
            var passed, falback;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, func(req, res, scope)];
                    case 1:
                        passed = _a.sent();
                        if (!this.failurable || passed) {
                            return [2, true];
                        }
                        falback = this.getFallback(req, scope);
                        if (falback instanceof Function) {
                            falback(true, req, res, scope);
                        }
                        else {
                            this.onAuthorFailed(true, req, res, scope);
                        }
                        return [2, false];
                }
            });
        });
    };
    return VHTTPBase;
}(VBase_1.VBase));
exports.VHTTPBase = VHTTPBase;
//# sourceMappingURL=VHTTPBase.js.map