"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var uploader = require("file-cloud-uploader");
var async = require("async");
var skipper = require("skipper");
var VFile = (function () {
    function VFile() {
    }
    VFile.prototype.cloud = function (req) {
        var _this = this;
        return function (name, options) {
            return new Promise(function (resolve, reject) {
                req.file(name).upload(function (err, files) {
                    _this._isError(err, resolve, function () {
                        var cloudFiles = [];
                        async.each(files, function (file, cb) {
                            uploader(options.type, file.fd, options.config, function (data) {
                                cloudFiles.push(data);
                                cb();
                            });
                        }, function (err1) {
                            _this._isError(err1, reject, function () {
                                resolve(cloudFiles);
                            });
                        });
                    });
                });
            });
        };
    };
    VFile.prototype.attach = function (app) {
        app.use(skipper());
        app.use(this.use());
    };
    VFile.prototype.use = function () {
        var _this = this;
        return function (req, res, next) {
            req.cloud = _this.cloud(req);
            next();
        };
    };
    VFile.prototype._isError = function (err, reject, cb) {
        if (cb === void 0) { cb = null; }
        if (err) {
            return reject(err);
        }
        if (cb instanceof Function) {
            cb();
        }
    };
    return VFile;
}());
exports.VFile = VFile;
//# sourceMappingURL=VFile.js.map