"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var VHTTPBase_1 = require("../Components/VHTTPBase");
var validator = require("node-form-validator");
var VValidator = (function (_super) {
    __extends(VValidator, _super);
    function VValidator(path) {
        if (path === void 0) { path = ""; }
        var _this = _super.call(this, path) || this;
        _this.paramKeys = ["required", "params", "query", "body"];
        _this.failurable = true;
        _this.defaultPath = "validators";
        return _this;
    }
    VValidator.prototype.isType = function (item) {
        if (item instanceof Object) {
            for (var k in item) {
                if (typeof k === "string") {
                    if (this.paramKeys.indexOf(k) === -1) {
                        return false;
                    }
                    if (k === "required") {
                        if (!(item[k] instanceof Array)) {
                            return false;
                        }
                    }
                }
            }
        }
        return item instanceof Object || item instanceof Function;
    };
    VValidator.prototype.process = function (req, res, scope) {
        if (scope === void 0) { scope = null; }
        return __awaiter(this, void 0, void 0, function () {
            var handler, processed;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        handler = this.check(req);
                        if (!(handler instanceof Function)) return [3, 2];
                        return [4, this._onProcess(handler, req, res, scope)];
                    case 1: return [2, _a.sent()];
                    case 2:
                        if (!(handler && handler instanceof Object)) return [3, 4];
                        return [4, this.processObject(handler, req, res, scope)];
                    case 3:
                        processed = _a.sent();
                        return [2, processed];
                    case 4: return [2, true];
                }
            });
        });
    };
    VValidator.prototype.processObject = function (handler, req, res, scope) {
        return __awaiter(this, void 0, void 0, function () {
            var keys, fallback, _i, keys_1, key, result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        scope.extracted = {};
                        req.extracted = {};
                        keys = ["query", "params", "body"];
                        fallback = this.getFallback(req, scope);
                        _i = 0, keys_1 = keys;
                        _a.label = 1;
                    case 1:
                        if (!(_i < keys_1.length)) return [3, 7];
                        key = keys_1[_i];
                        if (!handler[key]) {
                            return [3, 6];
                        }
                        req[key] = req[key] || {};
                        if (!(Object.keys(req[key]).length <= 0)) return [3, 3];
                        if (!(handler.required instanceof Array)) {
                            return [3, 6];
                        }
                        if (handler.required.indexOf(key) === -1) {
                            return [3, 6];
                        }
                        return [4, this.onPassed(req, res, scope, new Error(key + " is required"), fallback)];
                    case 2: return [2, _a.sent()];
                    case 3:
                        result = validator.validate(req[key], handler[key]);
                        if (!(!result || result.code !== 0)) return [3, 5];
                        return [4, this.onPassed(req, res, scope, result, fallback)];
                    case 4: return [2, _a.sent()];
                    case 5:
                        scope.extracted[key] = result.data;
                        req.extracted[key] = result.data;
                        _a.label = 6;
                    case 6:
                        _i++;
                        return [3, 1];
                    case 7:
                        if (Object.keys(scope.extracted).length <= 0) {
                            delete scope.extracted;
                            delete req.extracted;
                        }
                        return [2, true];
                }
            });
        });
    };
    return VValidator;
}(VHTTPBase_1.VHTTPBase));
exports.VValidator = VValidator;
//# sourceMappingURL=VValidator.js.map