"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var nunjucks = require("nunjucks");
var path = require("path");
var _ = require("lodash");
var debug = require("debug");
var print = debug("VTemplate");
var VBase_1 = require("../Components/VBase");
var Filter_1 = require("./Filter");
var VTemplate = (function (_super) {
    __extends(VTemplate, _super);
    function VTemplate(dir) {
        var _this = _super.call(this, dir) || this;
        _this.initialized = false;
        _this.views = [];
        _this.defaultPath = "templates";
        var resolvedPath = path.resolve(dir, "./templates");
        _this.views.push(path.resolve(resolvedPath, "./views"));
        _this.tFilter = new Filter_1.Filter(resolvedPath);
        return _this;
    }
    VTemplate.prototype.isType = function (item) {
        return true;
    };
    VTemplate.prototype.getEnv = function () {
        if (this.initialized) {
            return this.env;
        }
        var views = this.getViews();
        var loader = new nunjucks.FileSystemLoader(views);
        var env = new nunjucks.Environment(loader, {
            autoescape: false
        });
        var filters = this.getFilters();
        for (var _i = 0, _a = Object.keys(filters); _i < _a.length; _i++) {
            var key = _a[_i];
            env.addFilter(key, filters[key]);
        }
        this.env = env;
        this.initialized = true;
        return env;
    };
    VTemplate.prototype.render = function (data, template, ext) {
        return this.getEnv().render(template + "." + ext, data);
    };
    VTemplate.prototype.setParent = function (p) {
        this.parent = p;
        this.initialized = false;
    };
    VTemplate.prototype.getFilters = function () {
        this.tFilter.loadOn();
        var filters = this.tFilter.get();
        if (!this.parent) {
            return filters;
        }
        var parent = this.parent.getFilters();
        return _.merge(parent, filters);
    };
    VTemplate.prototype.getViews = function () {
        if (!this.parent) {
            return this.views;
        }
        var views = this.parent.getViews();
        return views.concat(this.views);
    };
    return VTemplate;
}(VBase_1.VBase));
exports.VTemplate = VTemplate;
//# sourceMappingURL=VTemplate.js.map