"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var path_1 = require("path");
var VFallbackDefinition_1 = require("./DefinitionParsers/VFallbackDefinition");
var VPolicyDefinition_1 = require("./DefinitionParsers/VPolicyDefinition");
var VDefinition = (function () {
    function VDefinition(path) {
        var base = path_1.resolve(path);
        var definitionDir = path_1.resolve(base, "./definitions");
        this.fallback = new VFallbackDefinition_1.VFallbackDefinition(definitionDir);
        this.policy = new VPolicyDefinition_1.VPolicyDefinition(definitionDir);
        this.fallback.loadOn();
        this.policy.loadOn();
    }
    VDefinition.prototype.parse = function (scope) {
        var definitions = {};
        var fallbacks = this.fallback.get();
        var policies = this.policy.get();
        if (Object.keys(fallbacks).length > 0) {
            definitions.fallbacks = fallbacks;
        }
        if (Object.keys(policies).length > 0) {
            definitions.policies = policies;
        }
        if (Object.keys(definitions).length > 0) {
            scope.definitions = definitions;
        }
    };
    VDefinition.prototype.set = function (data) {
        if (data.fallbacks) {
            this.fallback.set(data.fallbacks);
        }
        if (data.policies) {
            this.policy.set(data.policies);
        }
    };
    return VDefinition;
}());
exports.VDefinition = VDefinition;
;
//# sourceMappingURL=VDefinition.js.map