"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var EventEmitter = require("events");
var VEvent = (function () {
    function VEvent() {
    }
    VEvent.prototype.add = function (events, isOnce) {
        if (isOnce === void 0) { isOnce = true; }
        var once = isOnce ? "once" : "on";
        if (!events) {
            return;
        }
        if (!events.names) {
            return;
        }
        if (!events.handlers) {
            return;
        }
        for (var _i = 0, _a = events.names; _i < _a.length; _i++) {
            var name = _a[_i];
            var handler = events.handlers[name];
            if (!handler) {
                continue;
            }
            VEvent.emitter[once](name, handler);
        }
    };
    VEvent.prototype.send = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        VEvent.emitter.emit.apply(VEvent.emitter, args);
    };
    VEvent.prototype.on = function (event, handler) {
        VEvent.emitter.on(event, handler);
    };
    VEvent.prototype.once = function (event, handler) {
        VEvent.emitter.once(event, handler);
    };
    VEvent.emitter = new EventEmitter();
    return VEvent;
}());
exports.VEvent = VEvent;
//# sourceMappingURL=VEvent.js.map