import { VDefinition } from "./VDefinition";
import { VConfig, VError, VModel, VMiddleware, VRouter, VEventReader, VWebSocket } from "./Components";
import { VFallback, VCondition, VPolicy, VValidator, VPager, VBody, VSession } from "./MiddlewareParsers";
import { VTemplate } from "./Templates/VTemplate";
export declare class VHandler {
    urls: string[];
    prefix: string;
    config: VConfig;
    condition: VCondition;
    error: VError;
    body: VBody;
    event: VEventReader;
    middleware: VMiddleware;
    model: VModel;
    policy: VPolicy;
    session: VSession;
    router: VRouter;
    validator: VValidator;
    fallback: VFallback;
    websocket: VWebSocket;
    pager: VPager;
    template: VTemplate;
    definition: VDefinition;
    protected path: string;
    private parent;
    private children;
    private eventHandler;
    private scope;
    private unmuted;
    constructor(urls?: string[], path?: string, prefix?: string);
    requireFile(name: string): void;
    setUrls(urls: string[]): void;
    setParent(p: VHandler): void;
    setPrefix(prefix: any): void;
    update(k: string, v: any): void;
    extend(method: any, cb: any): boolean;
    set(config: any): void;
    getScope(): any;
    updateFallbacks(): void;
    attach(app: any): void;
    loadStaticScope(): void;
    eventPrepare(): void;
    websocketPrepare(): void;
    getFixedScope(): any;
    checkMutable(module: any): boolean;
    processMuted(): void;
    run(req: any, res: any): Promise<void>;
    notFound(error: any, req: any, res: any): void;
    wsEvent(event: any, message: any, ws: any, req: any): Promise<void>;
    toJSON(): any;
    private initChildren();
    private loadDirectory(dir);
}
