"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var VWSServer_1 = require("./VWSServer");
var http = require("http");
var debug = require("debug");
var print = debug("vig:service");
var VService = (function () {
    function VService(options) {
        if (options === void 0) { options = {}; }
        options.ip = options.ip || "127.0.0.1";
        options.port = options.port || 8080;
        this.options = options;
    }
    VService.prototype.defaultRun = function () {
        var _a = this.options, port = _a.port, ip = _a.ip;
        print("Server Successfully Running On " + ip + ":" + port);
    };
    VService.prototype.start = function (app, cb) {
        var _this = this;
        var server = http.createServer(app);
        var vwss = VWSServer_1.VWSServer.getInstance();
        vwss.start(server);
        server.listen(this.options.port, this.options.ip, function () {
            _this.defaultRun();
            if (cb instanceof Function) {
                cb(server, _this.options, vwss);
            }
        });
    };
    return VService;
}());
exports.VService = VService;
//# sourceMappingURL=VService.js.map