"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var WebSocket = require("ws");
var debug = require("debug");
var print = debug("vig:vwss");
var VWSServer = (function () {
    function VWSServer() {
        this.eventsAndListeners = {};
    }
    VWSServer.getInstance = function () {
        if (VWSServer.instance) {
            return VWSServer.instance;
        }
        VWSServer.instance = new VWSServer();
        return VWSServer.instance;
    };
    VWSServer.prototype.addEventListener = function (event, handler) {
        var handlers = this.eventsAndListeners[event];
        if (!(handlers instanceof Array)) {
            handlers = [];
        }
        if (handlers.indexOf(handler) === -1) {
            handlers.push(handler);
        }
        this.eventsAndListeners[event] = handlers;
    };
    VWSServer.prototype.broadcast = function (data, filter) {
        var _this = this;
        var wss = this.server;
        wss.clients.forEach(function (client) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                if (filter && !filter(client)) {
                    return [2];
                }
                if (client.readyState === WebSocket.OPEN) {
                    client.send(data);
                }
                return [2];
            });
        }); });
    };
    VWSServer.prototype.onEvent = function (event, ws, req) {
        return __awaiter(this, void 0, void 0, function () {
            var enterListeners, _i, enterListeners_1, handler;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        enterListeners = this.eventsAndListeners[event];
                        _i = 0, enterListeners_1 = enterListeners;
                        _a.label = 1;
                    case 1:
                        if (!(_i < enterListeners_1.length)) return [3, 4];
                        handler = enterListeners_1[_i];
                        return [4, handler.wsEvent(event, null, ws, req)];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3:
                        _i++;
                        return [3, 1];
                    case 4: return [2];
                }
            });
        });
    };
    VWSServer.prototype.onEnter = function (ws, req) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this.onEvent(VWSServer.ENTER, ws, req)];
                    case 1:
                        _a.sent();
                        return [2];
                }
            });
        });
    };
    VWSServer.prototype.onLeave = function (ws, req) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this.onEvent(VWSServer.LEAVE, ws, req)];
                    case 1:
                        _a.sent();
                        return [2];
                }
            });
        });
    };
    VWSServer.prototype.onEvents = function (ws, req) {
        var _this = this;
        ws.on("message", function (data) { return __awaiter(_this, void 0, void 0, function () {
            var json, event, message, eventListeners, _i, eventListeners_1, handler, e_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 5, , 6]);
                        json = JSON.parse(data);
                        event = json.event;
                        message = json.message;
                        eventListeners = this.eventsAndListeners[event];
                        if (!eventListeners) {
                            return [2];
                        }
                        _i = 0, eventListeners_1 = eventListeners;
                        _a.label = 1;
                    case 1:
                        if (!(_i < eventListeners_1.length)) return [3, 4];
                        handler = eventListeners_1[_i];
                        return [4, handler.wsEvent(event, message, ws, req)];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3:
                        _i++;
                        return [3, 1];
                    case 4: return [3, 6];
                    case 5:
                        e_1 = _a.sent();
                        print(e_1);
                        return [2];
                    case 6: return [2];
                }
            });
        }); });
    };
    VWSServer.prototype.start = function (server) {
        var _this = this;
        var wss = new WebSocket.Server({ server: server });
        this.server = wss;
        wss.on("connection", function (ws, req) { return __awaiter(_this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this.onEnter(ws, req)];
                    case 1:
                        _a.sent();
                        this.onEvents(ws, req);
                        ws.on("close", function () { return __awaiter(_this, void 0, void 0, function () {
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0: return [4, this.onLeave(ws, req)];
                                    case 1:
                                        _a.sent();
                                        return [2];
                                }
                            });
                        }); });
                        return [2];
                }
            });
        }); });
    };
    VWSServer.ENTER = "enter";
    VWSServer.LEAVE = "leave";
    return VWSServer;
}());
exports.VWSServer = VWSServer;
//# sourceMappingURL=VWSServer.js.map